rTriang <- function(j,size=1) {
  v <- 0:(j-1)
  p <- 2*(j-(0:(j-1)))/(j*(j+1))
  return(sample(v,size=size,replace=TRUE,prob=p))
}

pmelTriang <-function(Supp, proba=1) {
  m <- max(Supp)
  Tj <- Tri1(m)[Supp,]
  proba <- proba/sum(proba)
  p <- apply(diag(proba)%*%Tj,2,sum)
}

rmelTriang <-function(Supp, proba=1, size=1) {
  # random generation for a mixture of triangular distributions
  #
  # INPUT
  # Supp : vector containing the max support of the mixture
  # proba : vector of the same length as Sipp, containing the
  #      probabilities of each tringlar distribution
  # size : the size of the sample
  #
  # OUTPUT
  # vector of length size
  if (length(Supp) > 1) {
    proba <- proba/sum(proba)
    j <- sample(Supp,size=size,replace=TRUE,prob=proba)
    return(unlist(lapply(j,rTriang,size=1)))
  }
  if (length(Supp)==1) return(rTriang(Supp,size=size))
}

pChap <- function(X) {
  supp <- seq(min(X),max(X),by=1)
  count <- rep(0,length(supp))
  for (i in 1:length(supp)) {
   count[i] <- sum(X==supp[i])
  }
  pChap=count/length(X)
  return(list(support=supp,count=count,freq=pChap))
}
